/* window.c generated by valac 0.56.14, the Vala compiler
 * generated from window.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "gnome-pomodoro.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>

#define POMODORO_WINDOW_MIN_WIDTH 500
#define POMODORO_WINDOW_MIN_HEIGHT 650
#define POMODORO_WINDOW_FADED_IN 1.0
#define POMODORO_WINDOW_FADED_OUT 0.2
#define POMODORO_WINDOW_TIMER_LINE_WIDTH 6.0
#define POMODORO_WINDOW_TIMER_RADIUS 165.0

enum  {
	POMODORO_WINDOW_0_PROPERTY,
	POMODORO_WINDOW_MODE_PROPERTY,
	POMODORO_WINDOW_DEFAULT_MODE_PROPERTY,
	POMODORO_WINDOW_NUM_PROPERTIES
};
static GParamSpec* pomodoro_window_properties[POMODORO_WINDOW_NUM_PROPERTIES];

#define POMODORO_WINDOW_TYPE_NAME (pomodoro_window_name_get_type ())
typedef struct _PomodoroWindowName PomodoroWindowName;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PomodoroWindowPrivate {
	PomodoroTimer* timer;
	GtkStack* stack;
	GtkStack* timer_stack;
	GtkToggleButton* state_togglebutton;
	GtkLabel* minutes_label;
	GtkLabel* seconds_label;
	GtkWidget* timer_box;
	GtkButton* pause_resume_button;
	GtkButton* skip_stop_button;
	GtkImage* pause_resume_image;
	GtkImage* skip_stop_image;
	PomodoroAnimation* blink_animation;
	gchar* default_page;
};

struct _PomodoroWindowName {
	gchar* name;
	gchar* display_name;
};

static gint PomodoroWindow_private_offset;
static gpointer pomodoro_window_parent_class = NULL;
static GtkBuildableIface * pomodoro_window_gtk_buildable_parent_iface = NULL;

static GType pomodoro_window_name_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static PomodoroWindowName* pomodoro_window_name_dup (const PomodoroWindowName* self);
static void pomodoro_window_name_free (PomodoroWindowName* self);
static void pomodoro_window_name_copy (const PomodoroWindowName* self,
                                PomodoroWindowName* dest);
static void pomodoro_window_name_destroy (PomodoroWindowName* self);
static void pomodoro_window_real_parser_finished (GtkBuildable* base,
                                           GtkBuilder* builder);
static void pomodoro_window_on_timer_state_notify (PomodoroWindow* self);
static void _pomodoro_window_on_timer_state_notify_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void pomodoro_window_on_timer_elapsed_notify (PomodoroWindow* self);
static void _pomodoro_window_on_timer_elapsed_notify_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void pomodoro_window_on_timer_is_paused_notify (PomodoroWindow* self);
static void _pomodoro_window_on_timer_is_paused_notify_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void pomodoro_window_update_buttons (PomodoroWindow* self);
static void pomodoro_window_on_blink_animation_complete (PomodoroWindow* self);
static void _pomodoro_window_on_blink_animation_complete_pomodoro_animation_complete (PomodoroAnimation* _sender,
                                                                               gpointer self);
static gboolean pomodoro_window_on_timer_box_draw (PomodoroWindow* self,
                                            GtkWidget* widget,
                                            cairo_t* context);
static gboolean _pomodoro_window_on_timer_box_draw_gtk_widget_draw (GtkWidget* _sender,
                                                             cairo_t* cr,
                                                             gpointer self);
static gboolean pomodoro_window_on_button_press (PomodoroWindow* self,
                                          GtkWidget* widget,
                                          GdkEventButton* event);
static gboolean _pomodoro_window_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self);
static GObject * pomodoro_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void pomodoro_window_finalize (GObject * obj);
static GType pomodoro_window_get_type_once (void);
static void _vala_pomodoro_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_pomodoro_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static const PomodoroWindowName POMODORO_WINDOW_STATE_NAMES[4] = {{"null", ""}, {"pomodoro", N_ ("Pomodoro")}, {"short-break", N_ ("Short Break")}, {"long-break", N_ ("Long Break")}};

static inline gpointer
pomodoro_window_get_instance_private (PomodoroWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroWindow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 124 "../src/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 152 "window.c"
}

static void
_pomodoro_window_on_timer_state_notify_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 130 "../src/window.vala"
	pomodoro_window_on_timer_state_notify ((PomodoroWindow*) self);
#line 162 "window.c"
}

static void
_pomodoro_window_on_timer_elapsed_notify_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 131 "../src/window.vala"
	pomodoro_window_on_timer_elapsed_notify ((PomodoroWindow*) self);
#line 172 "window.c"
}

static void
_pomodoro_window_on_timer_is_paused_notify_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 132 "../src/window.vala"
	pomodoro_window_on_timer_is_paused_notify ((PomodoroWindow*) self);
#line 182 "window.c"
}

static void
pomodoro_window_real_parser_finished (GtkBuildable* base,
                                      GtkBuilder* builder)
{
	PomodoroWindow * self;
	PomodoroTimer* _tmp0_;
	PomodoroTimer* _tmp1_;
	GActionGroup* _tmp2_;
	GActionGroup* _tmp3_;
	GObject* state_togglebutton = NULL;
	GObject* _tmp4_;
	GObject* _tmp5_;
	GObject* _tmp6_;
	PomodoroTimer* _tmp7_;
	PomodoroTimer* _tmp8_;
	PomodoroTimer* _tmp9_;
#line 117 "../src/window.vala"
	self = (PomodoroWindow*) base;
#line 117 "../src/window.vala"
	g_return_if_fail (builder != NULL);
#line 119 "../src/window.vala"
	_tmp0_ = pomodoro_timer_get_default ();
#line 119 "../src/window.vala"
	self->priv->timer = _tmp0_;
#line 120 "../src/window.vala"
	_tmp1_ = self->priv->timer;
#line 120 "../src/window.vala"
	_tmp2_ = pomodoro_timer_get_action_group (_tmp1_);
#line 120 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 120 "../src/window.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "timer", _tmp3_);
#line 120 "../src/window.vala"
	_g_object_unref0 (_tmp3_);
#line 122 "../src/window.vala"
	pomodoro_window_gtk_buildable_parent_iface->parser_finished ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), builder);
#line 124 "../src/window.vala"
	_tmp4_ = gtk_builder_get_object (builder, "state_togglebutton");
#line 124 "../src/window.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 124 "../src/window.vala"
	state_togglebutton = _tmp5_;
#line 125 "../src/window.vala"
	_tmp6_ = gtk_builder_get_object (builder, "state_popover");
#line 125 "../src/window.vala"
	g_object_bind_property_with_closures (state_togglebutton, "active", _tmp6_, "visible", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 130 "../src/window.vala"
	_tmp7_ = self->priv->timer;
#line 130 "../src/window.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::state", (GCallback) _pomodoro_window_on_timer_state_notify_g_object_notify, self, G_CONNECT_AFTER);
#line 131 "../src/window.vala"
	_tmp8_ = self->priv->timer;
#line 131 "../src/window.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify::elapsed", (GCallback) _pomodoro_window_on_timer_elapsed_notify_g_object_notify, self, G_CONNECT_AFTER);
#line 132 "../src/window.vala"
	_tmp9_ = self->priv->timer;
#line 132 "../src/window.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::is-paused", (GCallback) _pomodoro_window_on_timer_is_paused_notify_g_object_notify, self, G_CONNECT_AFTER);
#line 117 "../src/window.vala"
	_g_object_unref0 (state_togglebutton);
#line 245 "window.c"
}

static void
pomodoro_window_update_buttons (PomodoroWindow* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	PomodoroTimer* _tmp11_;
	PomodoroTimerState* _tmp12_;
	PomodoroTimerState* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GQuark _tmp18_ = 0U;
#line 150 "../src/window.vala"
	static GQuark _tmp17_label0 = 0;
#line 150 "../src/window.vala"
	static GQuark _tmp17_label1 = 0;
#line 150 "../src/window.vala"
	static GQuark _tmp17_label2 = 0;
#line 135 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/window.vala"
	_tmp0_ = self->priv->timer;
#line 137 "../src/window.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 137 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 137 "../src/window.vala"
	if (_tmp2_) {
#line 277 "window.c"
		GtkImage* _tmp3_;
		GtkButton* _tmp4_;
		GtkImage* _tmp5_;
		GtkButton* _tmp6_;
#line 138 "../src/window.vala"
		_tmp3_ = self->priv->pause_resume_image;
#line 138 "../src/window.vala"
		g_object_set (_tmp3_, "icon-name", "media-playback-start-symbolic", NULL);
#line 139 "../src/window.vala"
		_tmp4_ = self->priv->pause_resume_button;
#line 139 "../src/window.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp4_, "timer.resume");
#line 140 "../src/window.vala"
		_tmp5_ = self->priv->skip_stop_image;
#line 140 "../src/window.vala"
		g_object_set (_tmp5_, "icon-name", "media-playback-stop-symbolic", NULL);
#line 141 "../src/window.vala"
		_tmp6_ = self->priv->skip_stop_button;
#line 141 "../src/window.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp6_, "timer.stop");
#line 298 "window.c"
	} else {
		GtkImage* _tmp7_;
		GtkButton* _tmp8_;
		GtkImage* _tmp9_;
		GtkButton* _tmp10_;
#line 144 "../src/window.vala"
		_tmp7_ = self->priv->pause_resume_image;
#line 144 "../src/window.vala"
		g_object_set (_tmp7_, "icon-name", "media-playback-pause-symbolic", NULL);
#line 145 "../src/window.vala"
		_tmp8_ = self->priv->pause_resume_button;
#line 145 "../src/window.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp8_, "timer.pause");
#line 146 "../src/window.vala"
		_tmp9_ = self->priv->skip_stop_image;
#line 146 "../src/window.vala"
		g_object_set (_tmp9_, "icon-name", "media-skip-forward-symbolic", NULL);
#line 147 "../src/window.vala"
		_tmp10_ = self->priv->skip_stop_button;
#line 147 "../src/window.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp10_, "timer.skip");
#line 320 "window.c"
	}
#line 150 "../src/window.vala"
	_tmp11_ = self->priv->timer;
#line 150 "../src/window.vala"
	_tmp12_ = pomodoro_timer_get_state (_tmp11_);
#line 150 "../src/window.vala"
	_tmp13_ = _tmp12_;
#line 150 "../src/window.vala"
	_tmp14_ = pomodoro_timer_state_get_name (_tmp13_);
#line 150 "../src/window.vala"
	_tmp15_ = _tmp14_;
#line 150 "../src/window.vala"
	_tmp16_ = _tmp15_;
#line 150 "../src/window.vala"
	_tmp18_ = (NULL == _tmp16_) ? 0 : g_quark_from_string (_tmp16_);
#line 150 "../src/window.vala"
	if (_tmp18_ == ((0 != _tmp17_label0) ? _tmp17_label0 : (_tmp17_label0 = g_quark_from_static_string ("pomodoro")))) {
#line 150 "../src/window.vala"
		switch (0) {
#line 340 "window.c"
			default:
			{
				PomodoroTimer* _tmp19_;
				gboolean _tmp20_;
				gboolean _tmp21_;
#line 153 "../src/window.vala"
				_tmp19_ = self->priv->timer;
#line 153 "../src/window.vala"
				_tmp20_ = pomodoro_timer_get_is_paused (_tmp19_);
#line 153 "../src/window.vala"
				_tmp21_ = _tmp20_;
#line 153 "../src/window.vala"
				if (_tmp21_) {
#line 354 "window.c"
					GtkButton* _tmp22_;
					GtkButton* _tmp23_;
#line 154 "../src/window.vala"
					_tmp22_ = self->priv->pause_resume_button;
#line 154 "../src/window.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp22_, _ ("Resume Pomodoro"));
#line 155 "../src/window.vala"
					_tmp23_ = self->priv->skip_stop_button;
#line 155 "../src/window.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp23_, _ ("Stop"));
#line 365 "window.c"
				} else {
					GtkButton* _tmp24_;
					GtkButton* _tmp25_;
#line 158 "../src/window.vala"
					_tmp24_ = self->priv->pause_resume_button;
#line 158 "../src/window.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp24_, _ ("Pause Pomodoro"));
#line 159 "../src/window.vala"
					_tmp25_ = self->priv->skip_stop_button;
#line 159 "../src/window.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp25_, _ ("Take a break"));
#line 377 "window.c"
				}
#line 162 "../src/window.vala"
				break;
#line 381 "window.c"
			}
		}
	} else if ((_tmp18_ == ((0 != _tmp17_label1) ? _tmp17_label1 : (_tmp17_label1 = g_quark_from_static_string ("short-break")))) || (_tmp18_ == ((0 != _tmp17_label2) ? _tmp17_label2 : (_tmp17_label2 = g_quark_from_static_string ("long-break"))))) {
#line 150 "../src/window.vala"
		switch (0) {
#line 387 "window.c"
			default:
			{
				PomodoroTimer* _tmp26_;
				gboolean _tmp27_;
				gboolean _tmp28_;
#line 166 "../src/window.vala"
				_tmp26_ = self->priv->timer;
#line 166 "../src/window.vala"
				_tmp27_ = pomodoro_timer_get_is_paused (_tmp26_);
#line 166 "../src/window.vala"
				_tmp28_ = _tmp27_;
#line 166 "../src/window.vala"
				if (_tmp28_) {
#line 401 "window.c"
					GtkButton* _tmp29_;
					GtkButton* _tmp30_;
#line 167 "../src/window.vala"
					_tmp29_ = self->priv->pause_resume_button;
#line 167 "../src/window.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _ ("Resume break"));
#line 168 "../src/window.vala"
					_tmp30_ = self->priv->skip_stop_button;
#line 168 "../src/window.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp30_, _ ("Stop"));
#line 412 "window.c"
				} else {
					GtkButton* _tmp31_;
					GtkButton* _tmp32_;
#line 171 "../src/window.vala"
					_tmp31_ = self->priv->pause_resume_button;
#line 171 "../src/window.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp31_, _ ("Pause break"));
#line 172 "../src/window.vala"
					_tmp32_ = self->priv->skip_stop_button;
#line 172 "../src/window.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _ ("Start Pomodoro"));
#line 424 "window.c"
				}
#line 174 "../src/window.vala"
				break;
#line 428 "window.c"
			}
		}
	} else {
#line 150 "../src/window.vala"
		switch (0) {
#line 434 "window.c"
			default:
			{
#line 177 "../src/window.vala"
				break;
#line 439 "window.c"
			}
		}
	}
}

static void
pomodoro_window_on_blink_animation_complete (PomodoroWindow* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 181 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/window.vala"
	_tmp0_ = self->priv->timer;
#line 183 "../src/window.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 183 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 183 "../src/window.vala"
	if (_tmp2_) {
#line 461 "window.c"
		PomodoroAnimation* _tmp3_;
#line 184 "../src/window.vala"
		_tmp3_ = self->priv->blink_animation;
#line 184 "../src/window.vala"
		pomodoro_animation_start_with_value (_tmp3_, 1.0);
#line 467 "window.c"
	}
}

static void
pomodoro_window_on_timer_state_notify (PomodoroWindow* self)
{
	const gchar* _tmp0_ = NULL;
	PomodoroTimer* _tmp1_;
	PomodoroTimerState* _tmp2_;
	PomodoroTimerState* _tmp3_;
	GtkStack* _tmp4_;
#line 188 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/window.vala"
	_tmp1_ = self->priv->timer;
#line 191 "../src/window.vala"
	_tmp2_ = pomodoro_timer_get_state (_tmp1_);
#line 191 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 191 "../src/window.vala"
	if (POMODORO_IS_DISABLED_STATE (_tmp3_)) {
#line 191 "../src/window.vala"
		_tmp0_ = "disabled";
#line 491 "window.c"
	} else {
#line 191 "../src/window.vala"
		_tmp0_ = "enabled";
#line 495 "window.c"
	}
#line 190 "../src/window.vala"
	_tmp4_ = self->priv->timer_stack;
#line 190 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp4_, _tmp0_);
#line 193 "../src/window.vala"
	pomodoro_window_update_buttons (self);
#line 503 "window.c"
	{
		PomodoroWindowName* mapping_collection = NULL;
		gint mapping_collection_length1 = 0;
		gint _mapping_collection_size_ = 0;
		gint mapping_it = 0;
#line 195 "../src/window.vala"
		mapping_collection = POMODORO_WINDOW_STATE_NAMES;
#line 195 "../src/window.vala"
		mapping_collection_length1 = G_N_ELEMENTS (POMODORO_WINDOW_STATE_NAMES);
#line 195 "../src/window.vala"
		for (mapping_it = 0; mapping_it < mapping_collection_length1; mapping_it = mapping_it + 1) {
#line 515 "window.c"
			PomodoroWindowName mapping = {0};
#line 195 "../src/window.vala"
			mapping = mapping_collection[mapping_it];
#line 519 "window.c"
			{
				gboolean _tmp5_ = FALSE;
				PomodoroWindowName _tmp6_;
				const gchar* _tmp7_;
				PomodoroTimer* _tmp8_;
				PomodoroTimerState* _tmp9_;
				PomodoroTimerState* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
#line 197 "../src/window.vala"
				_tmp6_ = mapping;
#line 197 "../src/window.vala"
				_tmp7_ = _tmp6_.name;
#line 197 "../src/window.vala"
				_tmp8_ = self->priv->timer;
#line 197 "../src/window.vala"
				_tmp9_ = pomodoro_timer_get_state (_tmp8_);
#line 197 "../src/window.vala"
				_tmp10_ = _tmp9_;
#line 197 "../src/window.vala"
				_tmp11_ = pomodoro_timer_state_get_name (_tmp10_);
#line 197 "../src/window.vala"
				_tmp12_ = _tmp11_;
#line 197 "../src/window.vala"
				if (g_strcmp0 (_tmp7_, _tmp12_) == 0) {
#line 545 "window.c"
					PomodoroWindowName _tmp13_;
					const gchar* _tmp14_;
#line 197 "../src/window.vala"
					_tmp13_ = mapping;
#line 197 "../src/window.vala"
					_tmp14_ = _tmp13_.display_name;
#line 197 "../src/window.vala"
					_tmp5_ = g_strcmp0 (_tmp14_, "") != 0;
#line 554 "window.c"
				} else {
#line 197 "../src/window.vala"
					_tmp5_ = FALSE;
#line 558 "window.c"
				}
#line 197 "../src/window.vala"
				if (_tmp5_) {
#line 562 "window.c"
					GtkToggleButton* _tmp15_;
					PomodoroWindowName _tmp16_;
					const gchar* _tmp17_;
#line 198 "../src/window.vala"
					_tmp15_ = self->priv->state_togglebutton;
#line 198 "../src/window.vala"
					_tmp16_ = mapping;
#line 198 "../src/window.vala"
					_tmp17_ = _tmp16_.display_name;
#line 198 "../src/window.vala"
					gtk_button_set_label ((GtkButton*) _tmp15_, _tmp17_);
#line 199 "../src/window.vala"
					break;
#line 576 "window.c"
				}
			}
		}
	}
}

static void
pomodoro_window_on_timer_elapsed_notify (PomodoroWindow* self)
{
	PomodoroTimer* _tmp0_;
	PomodoroTimerState* _tmp1_;
	PomodoroTimerState* _tmp2_;
#line 204 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/window.vala"
	_tmp0_ = self->priv->timer;
#line 206 "../src/window.vala"
	_tmp1_ = pomodoro_timer_get_state (_tmp0_);
#line 206 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 206 "../src/window.vala"
	if (!POMODORO_IS_DISABLED_STATE (_tmp2_)) {
#line 599 "window.c"
		guint remaining = 0U;
		PomodoroTimer* _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		guint minutes = 0U;
		guint seconds = 0U;
		GtkLabel* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GtkLabel* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GtkWidget* _tmp12_;
#line 208 "../src/window.vala"
		_tmp3_ = self->priv->timer;
#line 208 "../src/window.vala"
		_tmp4_ = pomodoro_timer_get_remaining (_tmp3_);
#line 208 "../src/window.vala"
		_tmp5_ = _tmp4_;
#line 208 "../src/window.vala"
		remaining = (guint) MAX (ceil (_tmp5_), 0.0);
#line 209 "../src/window.vala"
		minutes = remaining / 60;
#line 210 "../src/window.vala"
		seconds = remaining % 60;
#line 212 "../src/window.vala"
		_tmp6_ = self->priv->minutes_label;
#line 212 "../src/window.vala"
		_tmp7_ = g_strdup_printf ("%02u", minutes);
#line 212 "../src/window.vala"
		_tmp8_ = _tmp7_;
#line 212 "../src/window.vala"
		gtk_label_set_label (_tmp6_, _tmp8_);
#line 212 "../src/window.vala"
		_g_free0 (_tmp8_);
#line 213 "../src/window.vala"
		_tmp9_ = self->priv->seconds_label;
#line 213 "../src/window.vala"
		_tmp10_ = g_strdup_printf ("%02u", seconds);
#line 213 "../src/window.vala"
		_tmp11_ = _tmp10_;
#line 213 "../src/window.vala"
		gtk_label_set_label (_tmp9_, _tmp11_);
#line 213 "../src/window.vala"
		_g_free0 (_tmp11_);
#line 215 "../src/window.vala"
		_tmp12_ = self->priv->timer_box;
#line 215 "../src/window.vala"
		gtk_widget_queue_draw (_tmp12_);
#line 649 "window.c"
	}
}

static void
_pomodoro_window_on_blink_animation_complete_pomodoro_animation_complete (PomodoroAnimation* _sender,
                                                                          gpointer self)
{
#line 235 "../src/window.vala"
	pomodoro_window_on_blink_animation_complete ((PomodoroWindow*) self);
#line 659 "window.c"
}

static void
pomodoro_window_on_timer_is_paused_notify (PomodoroWindow* self)
{
	PomodoroAnimation* _tmp0_;
	PomodoroTimer* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 219 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/window.vala"
	_tmp0_ = self->priv->blink_animation;
#line 221 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 675 "window.c"
		PomodoroAnimation* _tmp1_;
#line 222 "../src/window.vala"
		_tmp1_ = self->priv->blink_animation;
#line 222 "../src/window.vala"
		pomodoro_animation_stop (_tmp1_);
#line 223 "../src/window.vala"
		_g_object_unref0 (self->priv->blink_animation);
#line 223 "../src/window.vala"
		self->priv->blink_animation = NULL;
#line 685 "window.c"
	}
#line 226 "../src/window.vala"
	pomodoro_window_update_buttons (self);
#line 228 "../src/window.vala"
	_tmp2_ = self->priv->timer;
#line 228 "../src/window.vala"
	_tmp3_ = pomodoro_timer_get_is_paused (_tmp2_);
#line 228 "../src/window.vala"
	_tmp4_ = _tmp3_;
#line 228 "../src/window.vala"
	if (_tmp4_) {
#line 697 "window.c"
		PomodoroAnimation* _tmp5_;
		PomodoroAnimation* _tmp6_;
		GtkWidget* _tmp7_;
		GValue _tmp8_ = {0};
		PomodoroAnimation* _tmp9_;
		PomodoroAnimation* _tmp10_;
#line 229 "../src/window.vala"
		_tmp5_ = pomodoro_animation_new (POMODORO_ANIMATION_MODE_BLINK, (guint) 2500, (guint) 25);
#line 229 "../src/window.vala"
		g_object_ref_sink (_tmp5_);
#line 229 "../src/window.vala"
		_g_object_unref0 (self->priv->blink_animation);
#line 229 "../src/window.vala"
		self->priv->blink_animation = _tmp5_;
#line 232 "../src/window.vala"
		_tmp6_ = self->priv->blink_animation;
#line 232 "../src/window.vala"
		_tmp7_ = self->priv->timer_box;
#line 232 "../src/window.vala"
		g_value_init (&_tmp8_, G_TYPE_DOUBLE);
#line 232 "../src/window.vala"
		g_value_set_double (&_tmp8_, POMODORO_WINDOW_FADED_OUT);
#line 232 "../src/window.vala"
		pomodoro_animation_add_property (_tmp6_, (GObject*) _tmp7_, "opacity", &_tmp8_);
#line 232 "../src/window.vala"
		G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
#line 235 "../src/window.vala"
		_tmp9_ = self->priv->blink_animation;
#line 235 "../src/window.vala"
		g_signal_connect_object (_tmp9_, "complete", (GCallback) _pomodoro_window_on_blink_animation_complete_pomodoro_animation_complete, self, 0);
#line 236 "../src/window.vala"
		_tmp10_ = self->priv->blink_animation;
#line 236 "../src/window.vala"
		pomodoro_animation_start_with_value (_tmp10_, 1.0);
#line 732 "window.c"
	} else {
		PomodoroAnimation* _tmp11_;
		PomodoroAnimation* _tmp12_;
		GtkWidget* _tmp13_;
		GValue _tmp14_ = {0};
		PomodoroAnimation* _tmp15_;
#line 239 "../src/window.vala"
		_tmp11_ = pomodoro_animation_new (POMODORO_ANIMATION_MODE_EASE_OUT, (guint) 200, (guint) 50);
#line 239 "../src/window.vala"
		g_object_ref_sink (_tmp11_);
#line 239 "../src/window.vala"
		_g_object_unref0 (self->priv->blink_animation);
#line 239 "../src/window.vala"
		self->priv->blink_animation = _tmp11_;
#line 242 "../src/window.vala"
		_tmp12_ = self->priv->blink_animation;
#line 242 "../src/window.vala"
		_tmp13_ = self->priv->timer_box;
#line 242 "../src/window.vala"
		g_value_init (&_tmp14_, G_TYPE_DOUBLE);
#line 242 "../src/window.vala"
		g_value_set_double (&_tmp14_, 1.0);
#line 242 "../src/window.vala"
		pomodoro_animation_add_property (_tmp12_, (GObject*) _tmp13_, "opacity", &_tmp14_);
#line 242 "../src/window.vala"
		G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
#line 245 "../src/window.vala"
		_tmp15_ = self->priv->blink_animation;
#line 245 "../src/window.vala"
		pomodoro_animation_start (_tmp15_);
#line 763 "window.c"
	}
}

static gboolean
pomodoro_window_on_timer_box_draw (PomodoroWindow* self,
                                   GtkWidget* widget,
                                   cairo_t* context)
{
	PomodoroTimer* _tmp0_;
	PomodoroTimerState* _tmp1_;
	PomodoroTimerState* _tmp2_;
	gboolean result;
#line 250 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 250 "../src/window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 250 "../src/window.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 253 "../src/window.vala"
	_tmp0_ = self->priv->timer;
#line 253 "../src/window.vala"
	_tmp1_ = pomodoro_timer_get_state (_tmp0_);
#line 253 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 253 "../src/window.vala"
	if (!POMODORO_IS_DISABLED_STATE (_tmp2_)) {
#line 790 "window.c"
		GtkStyleContext* style_context = NULL;
		GtkStyleContext* _tmp3_;
		GtkStyleContext* _tmp4_;
		GdkRGBA color = {0};
		GtkStyleContext* _tmp5_;
		GdkRGBA _tmp6_ = {0};
		gint width = 0;
		gint height = 0;
		gdouble x = 0.0;
		gdouble y = 0.0;
		gdouble _tmp7_ = 0.0;
		PomodoroTimer* _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gdouble progress = 0.0;
		gdouble angle1 = 0.0;
		gdouble angle2 = 0.0;
		GdkRGBA _tmp17_;
		GdkRGBA _tmp18_;
		GdkRGBA _tmp19_;
		GdkRGBA _tmp20_;
		GdkRGBA _tmp21_;
		GdkRGBA _tmp22_;
		GdkRGBA _tmp23_;
		GdkRGBA _tmp24_;
		GdkRGBA _tmp25_;
#line 255 "../src/window.vala"
		_tmp3_ = gtk_widget_get_style_context (widget);
#line 255 "../src/window.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 255 "../src/window.vala"
		style_context = _tmp4_;
#line 256 "../src/window.vala"
		_tmp5_ = style_context;
#line 256 "../src/window.vala"
		gtk_style_context_get_color (_tmp5_, gtk_widget_get_state_flags (widget), &_tmp6_);
#line 256 "../src/window.vala"
		color = _tmp6_;
#line 258 "../src/window.vala"
		width = gtk_widget_get_allocated_width (widget);
#line 259 "../src/window.vala"
		height = gtk_widget_get_allocated_height (widget);
#line 260 "../src/window.vala"
		x = 0.5 * width;
#line 261 "../src/window.vala"
		y = 0.5 * height;
#line 262 "../src/window.vala"
		_tmp8_ = self->priv->timer;
#line 262 "../src/window.vala"
		_tmp9_ = pomodoro_timer_get_state_duration (_tmp8_);
#line 262 "../src/window.vala"
		_tmp10_ = _tmp9_;
#line 262 "../src/window.vala"
		if (_tmp10_ > 0.0) {
#line 845 "window.c"
			PomodoroTimer* _tmp11_;
			gdouble _tmp12_;
			gdouble _tmp13_;
			PomodoroTimer* _tmp14_;
			gdouble _tmp15_;
			gdouble _tmp16_;
#line 263 "../src/window.vala"
			_tmp11_ = self->priv->timer;
#line 263 "../src/window.vala"
			_tmp12_ = pomodoro_timer_get_elapsed (_tmp11_);
#line 263 "../src/window.vala"
			_tmp13_ = _tmp12_;
#line 263 "../src/window.vala"
			_tmp14_ = self->priv->timer;
#line 263 "../src/window.vala"
			_tmp15_ = pomodoro_timer_get_state_duration (_tmp14_);
#line 263 "../src/window.vala"
			_tmp16_ = _tmp15_;
#line 263 "../src/window.vala"
			_tmp7_ = _tmp13_ / _tmp16_;
#line 866 "window.c"
		} else {
#line 263 "../src/window.vala"
			_tmp7_ = 0.0;
#line 870 "window.c"
		}
#line 262 "../src/window.vala"
		progress = _tmp7_;
#line 265 "../src/window.vala"
		angle1 = ((-0.5) * G_PI) - ((2.0 * G_PI) * CLAMP (progress, 0.000001, 1.0));
#line 266 "../src/window.vala"
		angle2 = (-0.5) * G_PI;
#line 268 "../src/window.vala"
		cairo_set_line_width (context, POMODORO_WINDOW_TIMER_LINE_WIDTH);
#line 270 "../src/window.vala"
		_tmp17_ = color;
#line 270 "../src/window.vala"
		_tmp18_ = color;
#line 270 "../src/window.vala"
		_tmp19_ = color;
#line 270 "../src/window.vala"
		_tmp20_ = color;
#line 270 "../src/window.vala"
		cairo_set_source_rgba (context, _tmp17_.red, _tmp18_.green, _tmp19_.blue, _tmp20_.alpha * 0.1);
#line 274 "../src/window.vala"
		cairo_arc (context, x, y, POMODORO_WINDOW_TIMER_RADIUS, 0.0, 2 * G_PI);
#line 275 "../src/window.vala"
		cairo_stroke (context);
#line 277 "../src/window.vala"
		cairo_set_line_cap (context, CAIRO_LINE_CAP_ROUND);
#line 278 "../src/window.vala"
		_tmp21_ = color;
#line 278 "../src/window.vala"
		_tmp22_ = color;
#line 278 "../src/window.vala"
		_tmp23_ = color;
#line 278 "../src/window.vala"
		_tmp24_ = color;
#line 278 "../src/window.vala"
		_tmp25_ = color;
#line 278 "../src/window.vala"
		cairo_set_source_rgba (context, _tmp21_.red, _tmp22_.green, _tmp23_.blue, (_tmp24_.alpha * POMODORO_WINDOW_FADED_IN) - ((_tmp25_.alpha * 0.1) * (1.0 - POMODORO_WINDOW_FADED_IN)));
#line 283 "../src/window.vala"
		cairo_arc_negative (context, x, y, POMODORO_WINDOW_TIMER_RADIUS, angle1, angle2);
#line 284 "../src/window.vala"
		cairo_stroke (context);
#line 253 "../src/window.vala"
		_g_object_unref0 (style_context);
#line 914 "window.c"
	}
#line 287 "../src/window.vala"
	result = FALSE;
#line 287 "../src/window.vala"
	return result;
#line 920 "window.c"
}

static gboolean
_pomodoro_window_on_timer_box_draw_gtk_widget_draw (GtkWidget* _sender,
                                                    cairo_t* cr,
                                                    gpointer self)
{
	gboolean result;
	result = pomodoro_window_on_timer_box_draw ((PomodoroWindow*) self, _sender, cr);
#line 25 "../src/window.vala"
	return result;
#line 932 "window.c"
}

static gboolean
pomodoro_window_on_button_press (PomodoroWindow* self,
                                 GtkWidget* widget,
                                 GdkEventButton* event)
{
	gboolean result;
#line 291 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 291 "../src/window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 291 "../src/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 294 "../src/window.vala"
	if (event->button == ((guint) 1)) {
#line 295 "../src/window.vala"
		gtk_window_begin_move_drag ((GtkWindow*) self, (gint) event->button, (gint) event->x_root, (gint) event->y_root, event->time);
#line 297 "../src/window.vala"
		result = TRUE;
#line 297 "../src/window.vala"
		return result;
#line 955 "window.c"
	}
#line 300 "../src/window.vala"
	result = FALSE;
#line 300 "../src/window.vala"
	return result;
#line 961 "window.c"
}

static gboolean
_pomodoro_window_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                GdkEventButton* event,
                                                                gpointer self)
{
	gboolean result;
	result = pomodoro_window_on_button_press ((PomodoroWindow*) self, _sender, event);
#line 25 "../src/window.vala"
	return result;
#line 973 "window.c"
}

PomodoroWindow*
pomodoro_window_construct (GType object_type)
{
	PomodoroWindow * self = NULL;
#line 25 "../src/window.vala"
	self = (PomodoroWindow*) g_object_new (object_type, NULL);
#line 25 "../src/window.vala"
	return self;
#line 984 "window.c"
}

PomodoroWindow*
pomodoro_window_new (void)
{
#line 25 "../src/window.vala"
	return pomodoro_window_construct (POMODORO_TYPE_WINDOW);
#line 992 "window.c"
}

const gchar*
pomodoro_window_get_mode (PomodoroWindow* self)
{
	const gchar* result;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 50 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/window.vala"
	_tmp0_ = self->priv->stack;
#line 51 "../src/window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 51 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 51 "../src/window.vala"
	result = _tmp2_;
#line 51 "../src/window.vala"
	return result;
#line 1014 "window.c"
}

void
pomodoro_window_set_mode (PomodoroWindow* self,
                          const gchar* value)
{
	GtkStack* _tmp0_;
#line 53 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/window.vala"
	_tmp0_ = self->priv->stack;
#line 54 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, value);
#line 53 "../src/window.vala"
	g_object_notify_by_pspec ((GObject *) self, pomodoro_window_properties[POMODORO_WINDOW_MODE_PROPERTY]);
#line 1030 "window.c"
}

const gchar*
pomodoro_window_get_default_mode (PomodoroWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 59 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/window.vala"
	_tmp0_ = self->priv->default_page;
#line 60 "../src/window.vala"
	result = _tmp0_;
#line 60 "../src/window.vala"
	return result;
#line 1046 "window.c"
}

static void
pomodoro_window_name_copy (const PomodoroWindowName* self,
                           PomodoroWindowName* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 36 "../src/window.vala"
	_tmp0_ = (*self).name;
#line 36 "../src/window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 36 "../src/window.vala"
	_g_free0 ((*dest).name);
#line 36 "../src/window.vala"
	(*dest).name = _tmp1_;
#line 36 "../src/window.vala"
	_tmp2_ = (*self).display_name;
#line 36 "../src/window.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 36 "../src/window.vala"
	_g_free0 ((*dest).display_name);
#line 36 "../src/window.vala"
	(*dest).display_name = _tmp3_;
#line 1073 "window.c"
}

static void
pomodoro_window_name_destroy (PomodoroWindowName* self)
{
#line 38 "../src/window.vala"
	_g_free0 ((*self).name);
#line 39 "../src/window.vala"
	_g_free0 ((*self).display_name);
#line 1083 "window.c"
}

static PomodoroWindowName*
pomodoro_window_name_dup (const PomodoroWindowName* self)
{
	PomodoroWindowName* dup;
#line 36 "../src/window.vala"
	dup = g_new0 (PomodoroWindowName, 1);
#line 36 "../src/window.vala"
	pomodoro_window_name_copy (self, dup);
#line 36 "../src/window.vala"
	return dup;
#line 1096 "window.c"
}

static void
pomodoro_window_name_free (PomodoroWindowName* self)
{
#line 36 "../src/window.vala"
	pomodoro_window_name_destroy (self);
#line 36 "../src/window.vala"
	g_free (self);
#line 1106 "window.c"
}

static GType
pomodoro_window_name_get_type_once (void)
{
	GType pomodoro_window_name_type_id;
	pomodoro_window_name_type_id = g_boxed_type_register_static ("PomodoroWindowName", (GBoxedCopyFunc) pomodoro_window_name_dup, (GBoxedFreeFunc) pomodoro_window_name_free);
	return pomodoro_window_name_type_id;
}

static GType
pomodoro_window_name_get_type (void)
{
	static volatile gsize pomodoro_window_name_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_window_name_type_id__once)) {
		GType pomodoro_window_name_type_id;
		pomodoro_window_name_type_id = pomodoro_window_name_get_type_once ();
		g_once_init_leave (&pomodoro_window_name_type_id__once, pomodoro_window_name_type_id);
	}
	return pomodoro_window_name_type_id__once;
}

static GObject *
pomodoro_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroWindow * self;
	GdkGeometry geometry = {0};
	GdkGeometry _tmp0_ = {0};
	GdkGeometry _tmp1_;
	GtkStack* _tmp2_;
	PomodoroStatsView* _tmp3_;
	PomodoroStatsView* _tmp4_;
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp5_;
	PomodoroApplication* _tmp6_;
	gchar* _tmp7_;
	GtkStack* _tmp8_;
	const gchar* _tmp9_;
#line 90 "../src/window.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_window_parent_class);
#line 90 "../src/window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 90 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_WINDOW, PomodoroWindow);
#line 92 "../src/window.vala"
	memset (&_tmp0_, 0, sizeof (GdkGeometry));
#line 92 "../src/window.vala"
	_tmp0_.min_width = POMODORO_WINDOW_MIN_WIDTH;
#line 92 "../src/window.vala"
	_tmp0_.max_width = -1;
#line 92 "../src/window.vala"
	_tmp0_.min_height = POMODORO_WINDOW_MIN_HEIGHT;
#line 92 "../src/window.vala"
	_tmp0_.max_height = -1;
#line 92 "../src/window.vala"
	geometry = _tmp0_;
#line 98 "../src/window.vala"
	_tmp1_ = geometry;
#line 98 "../src/window.vala"
	gtk_window_set_geometry_hints ((GtkWindow*) self, (GtkWidget*) self, &_tmp1_, GDK_HINT_MIN_SIZE);
#line 101 "../src/window.vala"
	_tmp2_ = self->priv->stack;
#line 101 "../src/window.vala"
	_tmp3_ = pomodoro_stats_view_new ();
#line 101 "../src/window.vala"
	g_object_ref_sink (_tmp3_);
#line 101 "../src/window.vala"
	_tmp4_ = _tmp3_;
#line 101 "../src/window.vala"
	gtk_stack_add_titled (_tmp2_, (GtkWidget*) _tmp4_, "stats", _ ("Stats"));
#line 101 "../src/window.vala"
	_g_object_unref0 (_tmp4_);
#line 104 "../src/window.vala"
	_tmp5_ = pomodoro_application_get_default ();
#line 104 "../src/window.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 104 "../src/window.vala"
	application = _tmp6_;
#line 106 "../src/window.vala"
	_tmp7_ = g_strdup ("timer");
#line 106 "../src/window.vala"
	_g_free0 (self->priv->default_page);
#line 106 "../src/window.vala"
	self->priv->default_page = _tmp7_;
#line 108 "../src/window.vala"
	_tmp8_ = self->priv->stack;
#line 108 "../src/window.vala"
	_tmp9_ = self->priv->default_page;
#line 108 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp8_, _tmp9_);
#line 110 "../src/window.vala"
	pomodoro_window_on_timer_state_notify (self);
#line 111 "../src/window.vala"
	pomodoro_window_on_timer_elapsed_notify (self);
#line 112 "../src/window.vala"
	pomodoro_window_on_timer_is_paused_notify (self);
#line 114 "../src/window.vala"
	pomodoro_window_update_buttons (self);
#line 90 "../src/window.vala"
	_g_object_unref0 (application);
#line 90 "../src/window.vala"
	return obj;
#line 1213 "window.c"
}

static void
pomodoro_window_class_init (PomodoroWindowClass * klass,
                            gpointer klass_data)
{
#line 25 "../src/window.vala"
	pomodoro_window_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/window.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroWindow_private_offset);
#line 25 "../src/window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_window_get_property;
#line 25 "../src/window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_window_set_property;
#line 25 "../src/window.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_window_constructor;
#line 25 "../src/window.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_window_finalize;
#line 25 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_WINDOW_MODE_PROPERTY, pomodoro_window_properties[POMODORO_WINDOW_MODE_PROPERTY] = g_param_spec_string ("mode", "mode", "mode", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_WINDOW_DEFAULT_MODE_PROPERTY, pomodoro_window_properties[POMODORO_WINDOW_DEFAULT_MODE_PROPERTY] = g_param_spec_string ("default-mode", "default-mode", "default-mode", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../src/window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/pomodoro/window.ui");
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, stack));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "timer_stack", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, timer_stack));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "state_togglebutton", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, state_togglebutton));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "minutes_label", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, minutes_label));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "seconds_label", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, seconds_label));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "timer_box", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, timer_box));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pause_resume_button", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, pause_resume_button));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "skip_stop_button", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, skip_stop_button));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pause_resume_image", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, pause_resume_image));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "skip_stop_image", FALSE, PomodoroWindow_private_offset + G_STRUCT_OFFSET (PomodoroWindowPrivate, skip_stop_image));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_timer_box_draw", G_CALLBACK(_pomodoro_window_on_timer_box_draw_gtk_widget_draw));
#line 25 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_button_press", G_CALLBACK(_pomodoro_window_on_button_press_gtk_widget_button_press_event));
#line 1262 "window.c"
}

static void
pomodoro_window_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                              gpointer iface_data)
{
#line 25 "../src/window.vala"
	pomodoro_window_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../src/window.vala"
	iface->parser_finished = (void (*) (GtkBuildable*, GtkBuilder*)) pomodoro_window_real_parser_finished;
#line 1273 "window.c"
}

static void
pomodoro_window_instance_init (PomodoroWindow * self,
                               gpointer klass)
{
#line 25 "../src/window.vala"
	self->priv = pomodoro_window_get_instance_private (self);
#line 25 "../src/window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1284 "window.c"
}

static void
pomodoro_window_finalize (GObject * obj)
{
	PomodoroWindow * self;
#line 25 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_WINDOW, PomodoroWindow);
#line 87 "../src/window.vala"
	_g_object_unref0 (self->priv->blink_animation);
#line 88 "../src/window.vala"
	_g_free0 (self->priv->default_page);
#line 25 "../src/window.vala"
	G_OBJECT_CLASS (pomodoro_window_parent_class)->finalize (obj);
#line 1299 "window.c"
}

static GType
pomodoro_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroWindow), 0, (GInstanceInitFunc) pomodoro_window_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) pomodoro_window_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType pomodoro_window_type_id;
	pomodoro_window_type_id = g_type_register_static (gtk_application_window_get_type (), "PomodoroWindow", &g_define_type_info, 0);
	g_type_add_interface_static (pomodoro_window_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	PomodoroWindow_private_offset = g_type_add_instance_private (pomodoro_window_type_id, sizeof (PomodoroWindowPrivate));
	return pomodoro_window_type_id;
}

GType
pomodoro_window_get_type (void)
{
	static volatile gsize pomodoro_window_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_window_type_id__once)) {
		GType pomodoro_window_type_id;
		pomodoro_window_type_id = pomodoro_window_get_type_once ();
		g_once_init_leave (&pomodoro_window_type_id__once, pomodoro_window_type_id);
	}
	return pomodoro_window_type_id__once;
}

static void
_vala_pomodoro_window_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	PomodoroWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_WINDOW, PomodoroWindow);
#line 25 "../src/window.vala"
	switch (property_id) {
#line 25 "../src/window.vala"
		case POMODORO_WINDOW_MODE_PROPERTY:
#line 25 "../src/window.vala"
		g_value_set_string (value, pomodoro_window_get_mode (self));
#line 25 "../src/window.vala"
		break;
#line 25 "../src/window.vala"
		case POMODORO_WINDOW_DEFAULT_MODE_PROPERTY:
#line 25 "../src/window.vala"
		g_value_set_string (value, pomodoro_window_get_default_mode (self));
#line 25 "../src/window.vala"
		break;
#line 1348 "window.c"
		default:
#line 25 "../src/window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/window.vala"
		break;
#line 1354 "window.c"
	}
}

static void
_vala_pomodoro_window_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	PomodoroWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_WINDOW, PomodoroWindow);
#line 25 "../src/window.vala"
	switch (property_id) {
#line 25 "../src/window.vala"
		case POMODORO_WINDOW_MODE_PROPERTY:
#line 25 "../src/window.vala"
		pomodoro_window_set_mode (self, g_value_get_string (value));
#line 25 "../src/window.vala"
		break;
#line 1374 "window.c"
		default:
#line 25 "../src/window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/window.vala"
		break;
#line 1380 "window.c"
	}
}

